<script setup lang="ts">
    import { onMounted, ref } from "vue";
    import PasswordField from "./PasswordField.vue";
    import { VRow, VBtn, VTextField, VAutocomplete } from "vuetify/components";
    import { VNumberInput } from "vuetify/labs/components";
    import toastr from "toastr";
    import { getBackendURL } from "../functions/backend";
    import { availablePaths } from "../functions/paths";

    let password = ref("");

    type QuestSelection = {
        start_timestamp: number;
        end_timestamp: number;
        name: string;
        quest_id: number;
    };

    type ViewControlStruct = {
        id: number;
        slug: string;
        name: string;
        password: string;
        quest_selections: QuestSelection[];
    };

    const controlStructs = ref([] as ViewControlStruct[]);

    function create() {
        fetch(getBackendURL("create-control-struct?secret=" + encodeURIComponent(password.value)), {
            method: "POST",
        })
            .then(async function (response) {
                if (response.ok) {
                    controlStructs.value = await response.json();
                } else {
                    toastr.error("Falsches Passwort oder Fehler");
                }
            })
            .catch((error) => {
                console.error("Could not load management-JSON", error);
                toastr.error("Unbekannter Fehler");
            });
    }

    function deleteCont(id: number) {
        if (confirm("Wirklich Löschen")) {
            fetch(getBackendURL("delete-control-struct?secret=" + encodeURIComponent(password.value)), {
                method: "POST",
                body: JSON.stringify({ id: id }),
                headers: {
                    "Content-Type": "application/json",
                },
            })
                .then(async function (response) {
                    if (response.ok) {
                        controlStructs.value = await response.json();
                        toastr.success("Daten aktualisiert");
                    } else {
                        toastr.error("Falsches Passwort oder Fehler");
                    }
                })
                .catch((error) => {
                    console.error("Could not load management-JSON", error);
                    toastr.error("Unbekannter Fehler");
                });
        }
    }

    function removeOneGroupSelection(structId: number, selectionId: number) {
        if (confirm("Untergruppe wirklich Löschen")) {
            controlStructs.value[structId].quest_selections.splice(selectionId, 1);
        }
    }

    function updateCont(data: ViewControlStruct) {
        const payload = { id: data.id, data: data } as any;
        delete payload.data.id;

        fetch(getBackendURL("update-control-struct?secret=" + encodeURIComponent(password.value)), {
            method: "POST",
            body: JSON.stringify(payload),
            headers: {
                "Content-Type": "application/json",
            },
        })
            .then(async function (response) {
                if (response.ok) {
                    controlStructs.value = await response.json();
                    toastr.success("Daten aktualisiert");
                } else {
                    toastr.error("Falsches Passwort oder Fehler");
                }
            })
            .catch((error) => {
                console.error("Could not load management-JSON", error);
                toastr.error("Unbekannter Fehler");
            });
    }

    const selectVals = [
        { value: -1, label: "Quest Id nicht aufgezeichnet" },
        ...Object.keys(availablePaths).map((key) => {
            const element = availablePaths[key];

            return {
                value: element.index,
                label: element.name,
            };
        }),
    ];

    onMounted(() => {
        fetch(getBackendURL("view-control-structs?secret=" + encodeURIComponent(password.value)), {
            method: "GET",
        })
            .then(async function (response) {
                if (response.ok) {
                    controlStructs.value = await response.json();
                } else {
                    toastr.error("Falsches Passwort oder Fehler");
                }
            })
            .catch((error) => {
                console.error("Could not load management-JSON", error);
                toastr.error("Unbekannter Fehler");
            });
    });
</script>

<template>
    <div class="container">
        <h1><router-link to="/">Wandertag App</router-link> - Managment</h1>

        <v-row class="justify-center mx-4 my-0">
            <PasswordField v-model="password" />

            <VBtn @click="create" class="v-col-3 mt-3">Neu erstellen</VBtn>

            <v-row
                class="justify-center v-col-12"
                v-for="(controlStruct, controlStructIndex) in controlStructs"
                :key="controlStruct.id"
            >
                <v-text-field class="v-col-8" v-model="controlStruct.name" density="compact" label="Name" :hide-details="true" />
                <v-text-field class="v-col-8" v-model="controlStruct.slug" density="compact" label="Slug" :hide-details="true" />
                <v-text-field
                    class="v-col-8"
                    v-model="controlStruct.password"
                    type="password"
                    density="compact"
                    label="Password"
                    :hide-details="true"
                />

                <v-expansion-panels variant="accordion" class="v-col-10">
                    <v-expansion-panel title="Gruppen/Routen Einstellungen">
                        <template v-slot:text>
                            <VBtn
                                @click="
                                    controlStruct.quest_selections.push({
                                        start_timestamp: 0,
                                        end_timestamp: 0,
                                        name: 'replaceme',
                                        quest_id: -1,
                                    })
                                "
                                class="v-col-8"
                                >Neue Quest Auswahl</VBtn
                            >

                            <v-row
                                class="justify-center v-col-12"
                                v-for="(quest_selection, index) in controlStruct.quest_selections"
                                :key="index"
                            >
                                <v-autocomplete
                                    class="v-col-8"
                                    :hide-details="true"
                                    v-model="quest_selection.quest_id"
                                    label="Quest Id"
                                    :items="selectVals"
                                    density="compact"
                                    item-title="label"
                                    item-value="value"
                                    :auto-select-first="true"
                                    @blur="
                                        (event: any) => {
                                            const data = event.srcElement._value;
                                            quest_selection.name = data; // hopefully keeps working
                                        }
                                    "
                                ></v-autocomplete>
                                <v-text-field
                                    class="v-col-8"
                                    v-model="quest_selection.name"
                                    density="compact"
                                    label="Name"
                                    :hide-details="true"
                                />
                                <v-number-input
                                    class="v-col-8"
                                    v-model="quest_selection.start_timestamp"
                                    density="compact"
                                    label="Start Auswahl"
                                    :hide-details="true"
                                />
                                <v-number-input
                                    class="v-col-8"
                                    v-model="quest_selection.end_timestamp"
                                    density="compact"
                                    label="Ende Auswahl"
                                    :hide-details="true"
                                />

                                <VBtn @click="removeOneGroupSelection(controlStructIndex, index)" class="v-col-8 mt-2"
                                    >Auswahl Entfernen</VBtn
                                >
                            </v-row>
                        </template>
                    </v-expansion-panel>
                </v-expansion-panels>

                <VBtn @click="updateCont(controlStruct)" class="v-col-8 mt-4">Speichern</VBtn>
                <VBtn @click="deleteCont(controlStruct.id)" class="v-col-8 mt-2">Löschen</VBtn>
                <v-divider class="v-col-9 mt-5"></v-divider>
            </v-row>
        </v-row>
    </div>
</template>

<style scoped></style>
